#pragma once

namespace ModelParser {

class Model;
class Variable;

class Likelihood
{
public:
	Likelihood(Model* model);
	~Likelihood();

	bool Parse(const std::string& line, unsigned int linenr);

	void WriteFunctionsHeader(std::ofstream& ofs) const;
	void WriteFunctionsSource(std::ofstream& ofs) const;
	void WriteSource(std::ofstream& ofs) const;

private:
	void AddCodeLine(const std::string& line);
	bool ParseDirectCode(const std::string& line, unsigned int linenr);
	bool ParseNormal(const std::string& contents, std::string& code, const std::string line, unsigned int linenr);
	bool ParseTDist(const std::string& contents, std::string& code, const std::string line, unsigned int linenr);
	const Model* model;
	
	std::string category;

	std::string data;
	std::vector<std::string> data_indexing;

	std::vector<std::string> code;
	std::string in_function;
	std::map<std::string, std::vector<std::string> > function_code;
	
	size_t sum_ix;
	size_t indent_ix;
};

}
