#pragma once

namespace bcm {

class RNG;

class BivariateGMM
{
public:
	BivariateGMM();
	~BivariateGMM();
	
	bool Initialize(boost::property_tree::ptree pt);

	bool Sample(Real& x, Real& y, RNG* rng) const;
	bool EvaluatePDF(Real& p, const Real x, const Real y) const;
	bool EvaluateLogPDF(Real& logp, const Real x, const Real y) const;

private:
	size_t num_components;
	VectorReal proportions;
	VectorReal mu1;
	VectorReal mu2;
	VectorReal sigma1;
	VectorReal sigma2;
	VectorReal correlation;
};

}
