#pragma once

#include "Prior.h"
#include "UnivariateMarginal.h"
#include "UnivariateMarginalGMM.h"

namespace bcm {

class PriorMarginalGMM : public Prior
{
public:
	PriorMarginalGMM(VariableSet* varset);
	virtual ~PriorMarginalGMM();
	
	virtual bool LoadFromXML(const std::string& filename);

	virtual bool EvaluateLogPDF(size_t threadix, const Real* values, Real& logp) const;
	virtual bool Sample(Real* values, RNG* rng) const;
	virtual bool EvaluateMarginalVariance(size_t i, Real& var) const;

protected:
	bool EvaluateMarginalLogPDF(size_t i, Real value, Real& logp) const;

	enum EMarginalType {
		MT_Invalid,
		MT_Regular,
		MT_GMM,
	};
	enum ETransform {
		Transform_Invalid,
		Transform_None,
		Transform_Log,
		Transform_Logit,
	};

	std::vector<EMarginalType> MarginalTypes;
	std::vector<ETransform> Transforms;
	std::vector<UnivariateMarginal*> Marginals_Regular;
	std::vector<UnivariateMarginalGMM*> Marginals_GMM;
};

}
