#pragma once

#include "RNG.h"
#include "Sampler.h"

namespace bcm {

class SamplerIS : public Sampler
{
public:
	SamplerIS(size_t num_threads);
	virtual ~SamplerIS();

	virtual size_t GetNumSamples() { return num_samples; }

private:
	virtual bool ParseImpl(const boost::program_options::variables_map& vm);
	virtual bool InitializeImpl();
	virtual ERunResult RunImpl();

	// Settings
	size_t num_samples;
	std::string proposal_file;
	
	// Run-time variables
	RNG* rng;
	Prior* proposal;
};

}
