#pragma once

namespace bcm {

class RNG;

class UnivariateMarginalGMM
{
public:
	UnivariateMarginalGMM();
	~UnivariateMarginalGMM();
	
	bool Initialize(boost::property_tree::ptree pt);

	bool Sample(Real& value, RNG* rng) const;
	bool EvaluatePDF(Real& p, const Real value) const;
	bool EvaluateLogPDF(Real& logp, const Real value) const;
	bool EvaluateVariance(Real& var) const;
	bool EvaluateVarianceLogTransformed(Real& var) const;

private:
	size_t num_components;
	VectorReal proportions;
	VectorReal mu;
	VectorReal sigma;
};

}
