#pragma once

namespace bcm {

class VariableSet
{
public:
	VariableSet();
	~VariableSet();

	bool LoadFromXML(const std::string& filename);
	void AddVariable(const std::string& name, bool logspace = false);

	inline size_t GetNumVariables() const { return Variables.size(); }
	inline const std::string& GetVariableName(size_t i) const { return Variables[i]; }
	size_t GetVariableIndex(const std::string& name, bool log_error=true) const;
	inline bool IsVariableLogSpace(size_t i) const { return IsLogSpace[i]; }

private:
	std::vector<std::string> Variables;
	std::vector<bool> IsLogSpace;
};

}
