#include "Utils.h"
#include "LikelihoodInitialValue.h"

LikelihoodInitialValue::LikelihoodInitialValue()
	: NumReplicates(0)
{
}

LikelihoodInitialValue::~LikelihoodInitialValue()
{
}

bool LikelihoodInitialValue::Load(const boost::property_tree::ptree& xml_node, const bcm::NetCDFDataFile* datafile)
{
	if (!LikelihoodPart::Load(xml_node, datafile)) {
		return false;
	}

	// Load the data into memory
	if (!datafile->GetDimensionSize("", DataNameWithoutIndex + "_replicates", &NumReplicates)) {
		return false;
	}

	Data.resize(NumReplicates);
	for (size_t ri = 0; ri < NumReplicates; ri++) {
		if (!LookupDataValue1D(datafile, ri, &Data[ri])) {
			return false;
		}
	}

	return true;
}

bool LikelihoodInitialValue::SetVariableSet(const bcm::VariableSet* variables)
{
	if (!LikelihoodPart::SetVariableSet(variables)) {
		return false;
	}

	return true;
}

bool LikelihoodInitialValue::EvaluateLogProbability(size_t threadix, const Real* values, SBMLModel* model, std::vector<Real> simulated_time, Real& logp)
{
	return true;
}
