#pragma once

#include "LikelihoodPart.h"

class LikelihoodInitialValue : public LikelihoodPart
{
public:
	LikelihoodInitialValue();
	virtual ~LikelihoodInitialValue();

	virtual bool Load(const boost::property_tree::ptree& xml_node, const bcm::NetCDFDataFile* datafile);
	virtual bool SetVariableSet(const bcm::VariableSet* variables);
	virtual bool EvaluateLogProbability(size_t threadix, const Real* values, SBMLModel* model, std::vector<Real> simulated_time, Real& logp);

private:
	size_t NumReplicates;
	std::vector<Real> Data;
};
